
/*
 * lab1.c
 */

#include "usart.h"
#include <stdlib.h>
#include <stdio.h>
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

#define SPEED 192
/* intreruperi pwm */
ISR(TIMER1_OVF_vect)
{
    PORTD |= (1 << PD4);
	PORTD |= (1 <<PD5);
}


ISR(TIMER1_COMPB_vect)
{
    PORTD &= ~(1 << PD4);
	
}

ISR(TIMER1_COMPA_vect)
{
    PORTD &= ~(1 << PD5);
	
}


/* timer0 ovf */
ISR(TIMER0_OVF_vect)
{
    PORTB |= (1 << PB3);
	PORTB |= (1 << PB4);
}

/* timer0 comp A & B */
ISR(TIMER0_COMPB_vect)
{
    PORTB &= ~(1 << PB3);
}

ISR(TIMER0_COMPA_vect)
{
    PORTB &= ~(1 << PB4);
}

/* timer2 ovf */
ISR(TIMER2_OVF_vect)
{
    PORTD |= (1 << PD7) | (1 << PD6);
}

/* timer2 comp A & B */
ISR(TIMER2_COMPB_vect)
{
    PORTD &= ~(1 << PD6);
}

ISR(TIMER2_COMPA_vect)
{
    PORTD &= ~(1 << PD7);
}

void PCINT_init()
{
    PCICR |= (1 << PCIE1);
    PCMSK1 |= (1 << PCINT8) | (1 << PCINT9);
}

void IO_init()
{
    /* LED-ul verde/albastru este pus ca iesire */
   // DDRB |= (1 << PB3);
    DDRD |= (1 << PD4) | (1<<PD5) | (1<<PD6) | (1<<PD7); //| (1 << PD7) 
	DDRB |= (1<<PB3) | (1<<PB4);
	DDRB |= (1<<PB1) | (1<<PB0)| (1<<PB5);
	
	/* mode */
	PORTB |= (1<<PB5);
	
	/* phase */
	PORTB &= ~(1<<PB0);
	PORTB &= ~(1<<PB1);
	
    /* butoanele sunt puse ca intrare, cu rezistenta de pull-up */
  //  DDRB &= ~( (1 << PB0) | (1 << PB1));
   // PORTB |= ( (1 << PB0) | (1 << PB1));
}

void timer0_init()
{
   // TODO

	TCCR0A |= (1 << COM0A1) | (1 << COM0A0) | (1 << COM0B0) | (1 << COM0B1) | (1 << WGM00) | (1 << WGM01);
	TCCR0B |= (1 << CS00);
	
	TIMSK0 |= (1 << OCIE0B) | (1 << OCIE0A) | (1 << TOIE0);
	
	OCR0B = 0xFF;
    OCR0A = 0xFF;
}

void timer2_init()
{
   // TODO

	TCCR2A |= (1 << COM2A1) | (1 << COM2A0) | (1 << COM2B0) | (1 << COM2B1) | (1 << WGM20) | (1 << WGM21);
	TCCR2B |= (1 << CS20);
	
	TIMSK2 |= (1 << OCIE2B) | (1 << OCIE2A) | (1 << TOIE2);
	
	OCR2B = 0xFF;
    OCR2A = 0xFF;
}

void timer1_init()
{
    /* Se foloseste modul Fast PWM cu prag pe ICR1 ?i
     * prescaler 1024 */
    TCCR1A |= (1 << WGM11) | (1 << COM1A0) | (1 << COM1A1) | (1 << COM1B0) | (1 << COM1B1);
    TCCR1B |= (1 << CS10) | (1 << WGM13) | (1 << WGM12);

    TIMSK1 |= (1 << OCIE1B) | (1 << TOIE1);

    /* modul curent numara pna la ICR1 */
    ICR1 = 0x2000;
    /* duty cycle-ul este setat ini?ial la 25% */
    OCR1B = ICR1;
    /* duty cycle-ul pentru speaker (OC1A) este la 50% */
    OCR1A = ICR1;
}



void increase_A(int x)
{
	OCR0A -= x;
}

void decrease_A(int x)
{
	OCR0A += x;
}

void increase_B(int x)
{
	OCR0B -=x;
}

void decrease_B(int x)
{
	OCR0B +=x;
}

void power_off()
{	
	OCR0A = OCR0B = 0xFF;
	PORTB &= ~(1<<PB0);
	PORTB &= ~(1<<PB1);
}
void right()
{
	int olda = OCR0A;
	int oldb = OCR0B;
	int oldd = PORTB;
	OCR0A = OCR0B = SPEED;
	PORTB |= (1 << PB0);
	PORTB &= ~(1 << PB1);
	_delay_ms(250);
	PORTB = oldd;
	OCR0A = olda;
	OCR0B = oldb;
}

void left()
{
	
	int olda = OCR0A;
	int oldb = OCR0B;
	int oldd = PORTB;
	OCR0A = OCR0B = SPEED;
	PORTB |= (1 << PB1);
	PORTB &= ~(1 << PB0);
	_delay_ms(250);
	PORTB = oldd;
	OCR0A = olda;
	OCR0B = oldb;
}

void forward()
{
	OCR0A = OCR0B = SPEED;	
	PORTB &= ~(1 << PB0) & ~(1 << PB1);
}

void backward()
{
	OCR0A = OCR0B = SPEED;
	PORTB |= (1 << PB0) | (1 << PB1);
}

void loop()
{
	char recv;

	for(;;) {
		
		
		recv = USART0_receive();
		if(recv == 'x')
			power_off();
		if(recv=='e' )
		{	
			increase_A(10);
			increase_B(10);
		}
		if(recv=='q')
		{	
			decrease_A(10);
			decrease_B(10);
		}
		if(recv=='d' || recv=='D')
			right();
		if(recv=='a' || recv=='A')
			left();
		if(recv=='w' || recv=='W')
			forward();
		if(recv=='s' || recv=='S')
			backward();
			
		//power_off();
	}

}

int main()
{
    //USART
	/*DDRD |= (1<<PD0);
	PIND |= (1<<PD0);
	DDRB &= ~(1<<PB3);
	DDRD &= ~(1<<PD1);
	PORTD |= (1<<PD1);
	PORTB |= (1<<PB3);*/
	_delay_ms(2000);
	
    USART0_init();
	IO_init();
    timer0_init();
	timer1_init();
	timer2_init();
	PCINT_init();
	loop();
  

//	exemplu_usart();


//  task1_usart();
//  task2_usart();
//  task3_usart();

    //LCD
//   LCD_init();

//  exemplu_lcd();
//  task1_lcd();
//  task2_lcd();
//  bonus_lcd();

    return 0;
}

